<template>
  <div>

    <div class="el-form-item">
      <ob-input
          v-model="formData.title"
          autocomplete="off"
          label="Наименование"
          placeholder="Укажите наименование"
          type="text"
          property="title"
          :required="true"
          :isValid="!isDublicate"
          :validation-message="dublicateMessage"
      />
    </div>

    <div class="el-form-item">
      <ob-select
          v-model="formData.locations"
          label="Локации, входящие в агломерацию"
          :remote-opt="{
            method: getLocations,
            arguments: {
            }
          }"
          is-auto-complete
          placeholder="Выберите один или несколько вариантов"
          position="top"
          :isStandart="true"
          :required="true"
          :is-dropdown="true"
          data-qa="locations"
      />
    </div>

    <template v-if="showError">
      <ob-alert
          hideCloseButton
          theme="danger"
          icon="alert"
      >
        Что-то в целом пошло не так. Повторите попытку еще раз. Если проблема повторится, обратитесь в службу поддержки.
      </ob-alert>
    </template>


    <div class="actions">
      <ob-button
          type="primary"
          :disabled="disableSaveBtn"
          label="Добавить"
          @click.native="onSubmit"
      />
      <ob-button
          type="flat"
          label="Отмена"
          @click.native="$emit('close')"
      />
    </div>
  </div>
</template>

<script>
import api from "@/api"
import {uuid as vue_uuid} from 'vue-uuid';
import obInput from "common-components/src/obComponents/obInput";
import obSelect from "common-components/src/obComponents/obSelect";
import obButton from "common-components/src/obComponents/obButton";
import obAlert from "common-components/src/obComponents/obAlert";
import { sortArray } from "common-components/src/helpers/common";

export default {
  name: "raylwayAgglomerationModal",

  components: {
    obInput,
    obSelect,
    obButton,
    obAlert
  },

  props: {
    agglomeration: {
      type: Object,
      default: null,
    }
  },

  data() {
    return {
      formData: {
        title: '',
        locations: []
      },
      initialLocations: [],
      allLocationsMap: {},
      showError: false,
      isDublicate: false,
      dublicateMessage: "Агломерация с таким наименованием уже есть. Укажите другое наименование"
    }
  },

  computed: {
    isNew() {
      return !this.agglomerationUuid;
    },

    agglomerationUuid() {
      return this.agglomeration ? this.agglomeration.uuid : null
    },

    disableSaveBtn() {
      return this.formData.title === '' || !this.hasReferencePositions || !this.hasRailwayStation;
    },

    hasReferencePositions() {
      return this.formData.locations.filter(uuid => {
        return this.allLocationsMap[uuid]?.locationTypeCode === 'REFERENCE_POSITION';
      }).length > 0;
    },

    hasRailwayStation() {
      return this.formData.locations.filter(uuid => {
        return this.allLocationsMap[uuid]?.locationTypeCode === 'RAILWAY_STATION';
      }).length > 0;
    },
  },

  async created() {
    this.init();
  },

  methods: {
    async init() {
      if (this.agglomeration) {
        this.formData.title = this.agglomeration.title;
        const locations = await this.getLocationsInAgglomeration(this.agglomeration.uuid);
        this.initialLocations = locations;
        this.allLocationsMap = this.locationsListToMap(locations, this.allLocationsMap);
        this.formData.locations = locations.map(loc => loc.uuid)
      }
    },

    async getLocationsInAgglomeration(uuid) {
      this.showError = false;
      try {
        return await api.locations.getLocationsInAgglomeration(uuid);
      } catch (e) {
        this.showError = true;
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
        return [];
      }
    },

    async getLocations({ query = '', page = 0, size = 20 }) {
      this.showError = false;
      try {
        const params = {
          query,
          page,
          size,
          uuid: this.agglomerationUuid
        }
        const data = await api.locations.getLocationsAvailableForAgglomeration(params);
        let locations = this.addSelectedLocations(data.content);
        locations = this.addIconToLocations(locations);
        this.allLocationsMap = this.locationsListToMap(locations, this.allLocationsMap);
        return sortArray(locations, 'title');

      } catch (e) {
        this.showError = true;
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка загрузки данных'
        })
        return [];
      }
    },

    addSelectedLocations(loadedLocations) {
      let locations = loadedLocations;
      let loadedLocationsMap = this.locationsListToMap(loadedLocations, {});
      this.formData.locations.forEach(uuid => {
        if (!loadedLocationsMap[uuid]) {
          if (this.allLocationsMap[uuid]) {
            locations.push(this.allLocationsMap[uuid]);
          } else {
            console.error(`No location data for ${uuid}`)
          }
        }
      })
      return locations;
    },

    addIconToLocations(locations) {
      return locations.map(loc => {
        switch (loc.locationTypeCode) {
          case 'REFERENCE_POSITION': {
            loc.icon = 'city-sm';
            break;
          }
          case 'RAILWAY_STATION': {
            loc.icon = 'train-sm';
            break;
          }
        }
        return loc;
      })
    },

    async onSubmit() {
      this.showError = false;
      this.isDublicate = false;
      const uuid = this.isNew ? vue_uuid.v4() : this.agglomerationUuid;
      try {
        if (this.isNew) {
          await api.locations.createAgglomeration(uuid, this.formData.title);
          this.saveLocations(uuid);
        } else {
          if (this.isTitleChanged()) {
            await api.locations.updateAgglomeration(uuid, this.formData.title);
          }
          this.saveLocations(uuid);
        }
      } catch (e) {
        if (e.status === 409) {
          this.isDublicate = true;
        } else {
          this.showError = true;
        }

        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка сохранения данных'
        })
      }
    },
    
    async saveLocations(uuid) {
      try {
        const isLocationChanged = this.isLocationChanged();
        if (isLocationChanged) {
          const params = this.formData.locations.map(uuid => this.allLocationsMap[uuid]);
          await api.locations.saveLocationsInAgglomeration(uuid, params);
          this.$emit("submitted")
        } else {
          this.$emit("submitted")
        }
      } catch (e) {
        this.showError = true;
        console.error(e);
        this.$notification({
          type: 'system_notification_error',
          message: 'Ошибка сохранения данных'
        })
      }
    },

    isTitleChanged() {
      return this.agglomeration.title !== this.formData.title;
    },

    isLocationChanged() {
      let changed = false;
      if (this.initialLocations.length !== this.formData.locations.length) {
        changed = true;
      } else {
        const currentMap = this.locationsListToMap(this.initialLocations, {});
        this.formData.locations.forEach(uuid => {
          if (!currentMap[uuid]) {
            changed = true;
          }
        })
      }
      return changed;
    },

    locationsListToMap(list, initialMap = {}) {
      return list.reduce((map, item) => {
        map[item.uuid] = item;
        return map;
      }, initialMap);
    }
  }
}
</script>

<style lang="scss">
@import"~common-components/src/static/css/modal-style.scss";
</style>

<style scoped lang="scss">
.actions {
  display: flex;
  margin-top: 40px;
}

</style>